<template>
  <div class="kit content">
    <div
      v-for="(feedback, index) in feedbacks"
      :key="index"
      class="kit review dialog">

      <div
        class="privat-icon"
        v-if="feedback.senderOrganizationLegalName === null">

        <img
          svg-inline
          src="~/assets/svg/privat.svg"
          alt="">

      </div>
      <div
        class="org-icon"
        v-else>
        <img
          svg-inline
          src="~/assets/svg/law-big.svg"
          alt="">
      </div>


      <div class="comment">
        <div class="header">
          <div class="user-name">
            {{ feedback.senderUserName }}
          </div>
          <rating :current-rating='feedback.rating'/>

        </div>
        <div class="text">
          {{ feedback.senderComment }}
        </div>
        <div class="footer">

          <div class="time">
            <img
              svg-inline
              src="~/assets/svg/date.svg"
              alt="">
            {{ feedback.createdAt | dateFormat({ time: true }) }}
          </div>
          <div class="right block">
            <div class="like-block">

              <div class="like-count">{{ feedback.likersCount }}</div>

              <div v-if="auth && !isSameUser">
                <img
                  svg-inline
                  src="~/assets/svg/like-outline.svg"
                  alt=""
                  @click="sending(index)"></div>
              <template v-else-if="auth === null">
                <v-popover
                  trigger="click"
                  popover-base-class="ui popup tooltip visible dark bottom with-auth">
                  <img
                    svg-inline
                    src="~/assets/svg/like-outline.svg">
                  <template slot="popover">
                    <div class="text">Необходима авторизация</div>
                    <a
                      class="link-login"
                      href="#"
                      @click.prevent="showAuthModal();"
                      v-close-popover>Войти</a>
                    <flink
                      class="link-reg"
                      href="/users/register"
                      domain="main"
                      rel="nofollow">Зарегистрироваться
                    </flink>
                  </template>
                </v-popover>
              </template>
              <div
                v-else-if="isSameUser"
                class="disabled">
                <img
                  svg-inline
                  src="~/assets/svg/like-outline.svg"
                  alt="">
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { createNamespacedHelpers } from 'vuex';
import { SHOW_AUTH_MODAL } from '~/assets/js/store/actionManager/mutation-types';
import Rating from '~/components/blocks/rating';

const STORE_ACTION_MANAGER = createNamespacedHelpers('actionManager');
const STORE_USER = createNamespacedHelpers('user');

export default {
  name: 'ReviewDialog',
  components: {
    rating: Rating,
  },
  props: {
    organizationId: {
      default: '',
      type: String,
    },
    feedbacks: {
      type: Array,
      default() { return []; },
    },
  },
  computed: {
    ...STORE_USER.mapState(['auth']),
    isSameUser() {
      return this.auth && Number(this.auth.id) === Number(this.organizationId);
    },
  },
  methods: {
    ...STORE_ACTION_MANAGER.mapMutations({
      showAuthModal: SHOW_AUTH_MODAL,
    }),
    async sending(index) {
      this.loading = true;
      await this.$axios.$post('/_main/feedback/addLike', {
        data: {
          feedbackId: Number(this.feedbacks[index].id),
        },
      }).then(({ data }) => {
        data && this.$emit('updateLikes', {
          feedbackId: Number(this.feedbacks[index].id),
          likersCount: data.likersCount,
        });
      });
      this.loading = false;
    },
  },
};
</script>

<style lang="scss" scoped>
  .kit.content {
    padding: 18px 44px;
    display: flex;
    flex-direction: column;
    // height: 500px;
    // overflow-y: auto;

    .kit.review.dialog {
      background: #fff;
      position: relative;
      border: 1px solid #c5d1d9;
      border-radius: 3px;
      box-shadow: 0 16px 58px 0 rgba(130, 158, 187, 0.08);
      color: #272727;
      padding: 11px 22px 0;
      margin-top: 24px;
      margin-left: 65px;

      &::before {
        content: '';
        background: #fff;
        border-top: 1px solid #c5d1d9;
        border-left: 1px solid #c5d1d9;
        position: absolute;
        height: 9px;
        width: 9px;
        top: 27px;
        left: -5px;
        -webkit-transform: rotate(-45deg);
        -ms-transform: rotate(-45deg);
        transform: rotate(-45deg);
        z-index: 1;
      }

      .privat-icon, .org-icon {
        > .svg {
          position: absolute;
          top: -29px;
          left: -65px;
          margin-right: 8px;
          margin-top: 30px;
          width: 2.875rem;
          height: 2.875rem;
          border-radius: 100%;
          @media screen and (max-width: 1024px) {
            width: 1.875rem;
            height: 1.875rem;
            left: -45px;
          }
        }
      }

      .comment {

        .header {
          justify-content: space-between;
          display: flex;

          .user-name {
            color: #272727;
            font-weight: 700;
            margin: 10px 0;
          }
          @media screen and (max-width: 360px) {
            flex-direction: column;
            justify-content: center;
            align-items: center;
          }
        }

        .text {
          font-size: 13px;
          color: #383838;
          line-height: 25px;
          max-height: 10000px;
          overflow: hidden;
        }

        > .footer {
          display: flex;
          -webkit-justify-content: space-between;
          align-items: center;
          padding-top: 8px;
          padding-bottom: 16px;

          >.time {
            align-items: baseline;
            display: flex;
            font-size: 11px;
            color: #6a7b87;

            .svg {
              margin-right: 5px;
              width: 10px;
              height: 10px;
            }
          }

          .right.block {
            display: flex;
            justify-content: flex-end;

            > .answer-block {
              margin-right: 9px;
              align-items: center;
              display: flex;

              .svg {
                height: 20px;
                width: 20px;

              }
            }

            > .like-block {
              font-size: 11px;
              color: #6a7b87;
              display: flex;
              cursor: pointer;

              .svg {
                margin-left: 5px;
                height: 17px;
                width: 17px;

                &:hover {
                  fill: #0d95e8;
                }
              }
            }
          }
        }
      }
    }
    .disabled{
      cursor:default ;
    }
  }

</style>
